%define _unpackaged_files_terminate_build 0
%define contentdir /home/httpd
%define suexec_caller nobody
%define mmn 20051115
%define vstring AnNyung
%define distro AnNyung
%define _with_embededapr 1

%{?_with_cent4:%define aprv 12}
%{?_with_embededapr:%define with_embededapr 1}
%{!?_with_embededapr:%define with_embededapr 0}

Summary: Apache HTTP Server
Summary(ko): 아파치 HTTP 서버
Name: httpd
Version: 2.2.32
Release: 1%{?dist}
Epoch: 1
URL: http://httpd.apache.org/
Source0: http://www.apache.org/dist/httpd/httpd-%{version}.tar.bz2
Source3: httpd.logrotate
Source4: httpd.init
Source5: httpd.sysconf
Source10: httpd.conf
Source11: welcome.conf
Source12: manual.conf
Source13: ssl.conf
Source14: proxy_ajp.conf
# Documentation
Source32: html.xsl

# Tmon index file
Source100: annyung-index.html
Source104: ServerError.tar.gz
Source105: blank.gif
Source106: httpd_callstack.sh

# build/scripts patches
Patch1: httpd-2.2.19-apctl.patch
Patch2: httpd-2.2.19-apxs.patch
Patch3: httpd-2.2.19-deplibs.patch
Patch4: httpd-2.2.19-disablemods.patch
Patch5: httpd-2.2.19-layout.patch
# Features/functional changes
Patch20: httpd-2.2.22-release.patch
Patch21: httpd-2.2.19-xfsz.patch
Patch22: httpd-2.2.23-pod.patch
Patch23: httpd-2.2.19-export.patch
Patch24: httpd-2.2.22-corelimit.patch
Patch25: httpd-2.2.22-selinux.patch
Patch26: httpd-2.2.31-ssl_npn.patch
# Bug fixes
Patch50: httpd-2.2.19-encode.patch
Patch51: httpd-2.2.19-authnoprov.patch
Patch52: httpd-2.2.19-logresline.patch

# AnNyung Patch
Patch101: httpd-annyung-embeded-apr.patch
Patch102: httpd-annyung-external-404-iframe.patch
Patch103: httpd-annyung-max-server-status-num.patch
Patch104: httpd-annyung-fixed-ssi-hangul.patch

# Security patch
Patch1000: httpd-2.2.15-CVE-2016-5387.patch
#Patch1001: httpd-2.2.27-CVE-2014-0226.patch
#Patch1002: httpd-2.2.27-CVE-2014-0231.patch

License: ASL 2.0
Group: System Environment/Daemons
BuildRoot: %{_tmppath}/%{name}-root
BuildRequires: autoconf, perl, pkgconfig, findutils
BuildRequires: db4-devel, expat-devel, zlib-devel, libselinux-devel, openldap-devel
%{!?_with_embededapr:BuildRequires: apr%{?aprv}-devel >= 1.2.0, apr%{?aprv}-util-devel >= 1.2.0}
%{!?_with_cent4:BuildRequires: pcre-devel >= 5.0} 
Requires: /etc/mime.types, gawk, /usr/bin/find, mailcap
Requires: initscripts httpd-conf-package
%{!?_with_embededapr:Requires: apr%{?aprv} apr%{?aprv}-util}
Requires(post): chkconfig
Obsoletes: httpd-suexec
BuildRequires: /sbin/chkconfig, /bin/mktemp, /bin/rm, /bin/mv
BuildRequires: sh-utils, textutils, /usr/sbin/useradd
Provides: webserver
Provides: httpd-mmn = %{mmn}
Obsoletes: secureweb, mod_dav, mod_gzip, stronghold-apache, stronghold-htdocs
Obsoletes: mod_put, mod_roaming, mod_jk
%{!?_with_cent4:Conflicts: pcre < 4.0}
Conflicts: apache

%description
The Apache HTTP Server is a powerful, efficient, and extensible
web server.

Building option:
	--with cent4 : if build on cent4

%package devel
Group: Development/Libraries
Summary: Development tools for the Apache HTTP server.
Summary(ko): 아파치 HTTP 서버를 이용한 개발 도구
Obsoletes: secureweb-devel, stronghold-apache-devel
%{!?_with_embededapr:Requires: apr%{?aprv}-devel, apr%{?aprv}-util-devel}
Requires: pkgconfig
Conflicts: apache-devel
#Requires: httpd

%description devel
The httpd-devel package contains the APXS binary and other files
that you need to build Dynamic Shared Objects (DSOs) for the
Apache HTTP Server.

If you are installing the Apache HTTP server and you want to be
able to compile or develop additional modules for Apache, you need
to install this package.

%package manual
Group: Documentation
Summary: Documentation for the Apache HTTP server.
Summary(ko): 아파치 HTTP 서버 문서
Requires: httpd
Obsoletes: secureweb-manual

%description manual
The httpd-manual package contains the complete manual and
reference guide for the Apache HTTP server. The information can
also be found at http://httpd.apache.org/docs/2.2/.

%package ssl
Group: System Environment/Daemons
Summary: SSL/TLS module for the Apache HTTP server
Summary(ko): 아파치 HTTP 서버 SSL/TLS 모듈
BuildRequires: openssl-devel
Requires(post): openssl, /bin/cat
Requires: httpd, httpd-mmn
Obsoletes: stronghold-mod_ssl

%description ssl
The mod_ssl module provides strong cryptography for the Apache Web
server via the Secure Sockets Layer (SSL) and Transport Layer
Security (TLS) protocols.

%package tools
Group: System Environment/Daemons
Summary: Tools for use with the Apache HTTP Server
Summary(ko): 아파치 HTTP 서버와 함께 사용할 수 있는 도구
Requires: gdb

%description tools
The httpd-tools package contains tools which can be used with
the Apache HTTP Server.

%prep
%setup -q -a 104

# security patch
%patch1000 -p1
#patch1001 -p1
#patch1002 -p1

%patch1 -p1 -b .apctl
%patch2 -p1 -b .apxs
%patch3 -p1 -b .deplibs
%patch4 -p1 -b .disablemods
%patch5 -p1 -b .layout

%patch21 -p1 -b .xfsz
%patch22 -p1 -b .pod
%patch23 -p1 -b .export
%patch24 -p1 -b .corelimit
%patch25 -p1 -b .selinux
%patch26 -p1 -b .npn

# no -b to prevent droplets in install root
%patch50 -p1
%patch51 -p1 -b .authnoprov
%patch52 -p1 -b .logresline

# AnNyung patch
%{?_with_embededapr:%patch101 -p1}
%patch102 -p1
%patch103 -p1
%patch104 -p1

# Patch in vendor/release string
sed "s/@VENDOR@/%{vstring}/;s/@RELEASE@/%{release}/" < %{PATCH20} | patch -p1 -b -z .release

# Safety check: prevent build if defined MMN does not equal upstream MMN.
vmmn=`echo MODULE_MAGIC_NUMBER_MAJOR | cpp -include include/ap_mmn.h | sed -n '/^2/p'`
if test "x${vmmn}" != "x%{mmn}"; then
   : Error: Upstream MMN is now ${vmmn}, packaged MMN is %{mmn}.
   : Update the mmn macro and rebuild.
   exit 1
fi

: Building for '%{distro}' with MMN %{mmn} and vendor string '%{vstring}'

%if %with_embededapr
rpm -q apr-devel &> /dev/null || chk="yes"
[ -z "$chk" ] && \
	echo "  !! Current build used embeded apr library." && \
	echo "  !! Please, remove apr-devel package on System." && \
	exit 1
rpm -q apr-util-devel &> /dev/null || chk="yes"
[ -z "$chk" ] && \
	echo "  !! Current build used embeded apr-util library." && \
	echo "  !! Please, remove apr-util-devel package on System." && \
	exit 1
%endif

%build
# forcibly prevent use of bundled apr, apr-util, pcre
%{!?_with_embededapr:rm -rf srclib/{apr,apr-util}}
%{!?_with_cent4:rm -rf srclib/pcre}

# regenerate configure scripts
autoheader && autoconf || exit 1

# Limit size of CHANGES to recent history
#echo '1,/Changes with Apache MPM/wq' | ed CHANGES

# Before configure; fix location of build dir in generated apxs
%{__perl} -pi -e "s:\@exp_installbuilddir\@:%{_libdir}/httpd/build:g" \
	support/apxs.in
# update location of migration guide in apachectl
%{__perl} -pi -e "s:\@docdir\@:%{_docdir}/%{name}-%{version}:g" \
	support/apachectl.in

CFLAGS=$RPM_OPT_FLAGS
SH_LDFLAGS="-Wl,-z,relro"
export CFLAGS SH_LDFLAGS

# Hard-code path to links to avoid unnecessary builddep
export LYNX_PATH=/usr/bin/links

function mpmbuild()
{
mpm=$1; shift
mkdir $mpm; pushd $mpm
../configure \
	--prefix=%{_sysconfdir}/httpd \
	--exec-prefix=%{_prefix} \
	--bindir=%{_bindir} \
	--sbindir=%{_sbindir} \
	--mandir=%{_mandir} \
	--libdir=%{_libdir} \
	--sysconfdir=%{_sysconfdir}/httpd/conf \
	--includedir=%{_includedir}/httpd \
	--libexecdir=%{_libdir}/httpd/modules \
	--datadir=%{contentdir} \
	--with-installbuilddir=%{_libdir}/httpd/build \
	--with-mpm=$mpm \
	%{!?_with_embededapr:--with-apr=%{_prefix} --with-apr-util=%{_prefix}} \
	%{?_with_embededapr:--with-included-apr} \
	--enable-suexec --with-suexec \
	--with-suexec-caller=%{suexec_caller} \
	--with-suexec-docroot=%{contentdir} \
	--with-suexec-logfile=%{_localstatedir}/log/httpd/suexec.log \
	--with-suexec-bin=%{_sbindir}/suexec \
	--with-suexec-uidmin=500 --with-suexec-gidmin=100 \
	--enable-pie \
	%{!?_with_cent4:--with-pcre} \
	$*

%{__mkdir_p} srclib/apr/tools
%{__mkdir_p} srclib/apr/include/private

%{__make} %{?_smp_mflags}
popd
}

# Build everything and the kitchen sink with the prefork build
mpmbuild prefork \
	--enable-mods-shared=all \
	--enable-ssl --with-ssl \
	--enable-proxy \
	--enable-cache --enable-mem-cache \
	--enable-file-cache --enable-disk-cache \
	--enable-ldap --enable-authnz-ldap \
	%{?_with_embededapr:--with-ldap} \
	--enable-cgid \
	--enable-authn-anon --enable-authn-alias

# For the other MPMs, just build httpd and no optional modules
mpmbuild worker --enable-modules=none
#mpmbuild event --enable-modules=none

%install
rm -rf %{buildroot}

# Classify ab and logresolve as section 1 commands, as they are in /usr/bin
#mv docs/man/ab.8 docs/man/ab.1
#mv docs/man/logresolve.8 docs/man/logresolve.1

pushd prefork
make DESTDIR=%{buildroot} install
popd

# install alternative MPMs
[ -f worker/.libs/httpd ] && \
	install -m 755 worker/.libs/httpd %{buildroot}%{_sbindir}/httpd.worker || \
	install -m 755 worker/httpd %{buildroot}%{_sbindir}/httpd.worker
#[ -f event/.libs/httpd ] && \
#	install -m 755 event/.libs/httpd %{buildroot}%{_sbindir}/httpd.event || \
#	install -m 755 event/httpd %{buildroot}%{_sbindir}/httpd.event \

# for holding mod_dav lock database
mkdir -p %{buildroot}%{_localstatedir}/lib/dav

# create a prototype session cache
mkdir -p %{buildroot}%{_localstatedir}/cache/mod_ssl
touch %{buildroot}%{_localstatedir}/cache/mod_ssl/scache.{dir,pag,sem}

# create cache root
mkdir %{buildroot}%{_localstatedir}/cache/mod_proxy

# move utilities to /usr/bin
mv %{buildroot}%{_sbindir}/{ab,htdbm,logresolve,htpasswd,htdigest} \
   %{buildroot}%{_bindir}

# Make the MMN accessible to module packages
echo %{mmn} > %{buildroot}%{_includedir}/httpd/.mmn

# remove manual sources
find %{buildroot}%{contentdir}/manual \( \
    -name \*.xml -o -name \*.xml.* -o -name \*.ent -o -name \*.xsl -o -name \*.dtd \
    \) -print0 | xargs -0 rm -f

# Strip the manual down just to English and replace the typemaps with flat files:
set +x
for f in `find %{buildroot}%{contentdir}/manual -name \*.html -type f`; do
   if test -f ${f}.en; then
      cp ${f}.en ${f}
      rm ${f}.*
   fi
done
set -x

# logs
rmdir %{buildroot}%{_sysconfdir}/httpd/logs
mkdir -p %{buildroot}%{_localstatedir}/log/httpd

# symlinks for %{_sysconfdir}/httpd
ln -s ../..%{_localstatedir}/log/httpd %{buildroot}%{_sysconfdir}/httpd/logs
ln -s ../..%{_localstatedir}/run %{buildroot}%{_sysconfdir}/httpd/run
ln -s ../..%{_libdir}/httpd/modules %{buildroot}%{_sysconfdir}/httpd/modules

# fix man page paths
sed -e "s|/usr/local/apache2/conf/httpd.conf|%{_sysconfdir}/httpd/conf/httpd.conf|" \
    -e "s|/usr/local/apache2/conf/mime.types|/etc/mime.types|" \
    -e "s|/usr/local/apache2/conf/magic|%{_sysconfdir}/httpd/conf/magic|" \
    -e "s|/usr/local/apache2/logs/error_log|/var/log/httpd/error_log|" \
    -e "s|/usr/local/apache2/logs/access_log|/var/log/httpd/access_log|" \
    -e "s|/usr/local/apache2/logs/httpd.pid|/var/run/httpd.pid|" \
    -e "s|/usr/local/apache2|%{_sysconfdir}/httpd|" < docs/man/httpd.8 \
  > %{buildroot}%{_mandir}/man8/httpd.8

# Make ap_config_layout.h libdir-agnostic
sed -i '/.*DEFAULT_..._LIBEXECDIR/d;/DEFAULT_..._INSTALLBUILDDIR/d' \
    %{buildroot}%{_includedir}/httpd/ap_config_layout.h

# Fix path to instdso in special.mk
sed -i '/instdso/s,top_srcdir,top_builddir,' \
    %{buildroot}%{_libdir}/httpd/build/special.mk

# Remove unpackaged files
mv %{buildroot}%{contentdir}/htdocs %{buildroot}%{contentdir}/html
rm -f %{buildroot}%{_libdir}/*.exp \
      %{buildroot}%{_sysconfdir}/httpd/conf/mime.types \
      %{buildroot}%{_libdir}/httpd/modules/*.exp \
      %{buildroot}%{_libdir}/httpd/build/config.nice \
      %{buildroot}%{_bindir}/ap?-config \
      %{buildroot}%{_sbindir}/{checkgid,dbmmanage,envvars*} \
      %{buildroot}%{contentdir}/html/* \
      %{buildroot}%{_mandir}/man1/dbmmanage.* \
      %{buildroot}%{contentdir}/cgi-bin/*

mkdir -p %{buildroot}%{_sysconfdir}/{rc.d/init.d,sysconfig,logrotate.d}
install -m644 %{SOURCE3} %{buildroot}%{_sysconfdir}/logrotate.d/httpd
install -m755 %{SOURCE4} %{buildroot}%{_sysconfdir}/rc.d/init.d/httpd
install -m644 %{SOURCE5} %{buildroot}%{_sysconfdir}/sysconfig/httpd

rm -rf %{buildroot}%{_sysconfdir}/httpd/conf/{original,extra}

mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d
mkdir -p %{buildroot}%{_sysconfdir}/httpd/user.d
install -m644 %{SOURCE10} %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf
install -m644 %{SOURCE11} %{buildroot}%{_sysconfdir}/httpd/user.d/welcome.conf
install -m644 %{SOURCE12} %{buildroot}%{_sysconfdir}/httpd/user.d/manual.conf
install -m644 %{SOURCE13} %{buildroot}%{_sysconfdir}/httpd/conf.d/ssl.conf
install -m644 %{SOURCE14} %{buildroot}%{_sysconfdir}/httpd/conf.d/proxy_ajp.conf

sed -i "s|@CONTENT_DIR@|%{contentdir}|g" %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf
#sed -i "s|@CONTENT_DIR@|%{contentdir}|g" %{buildroot}%{_sysconfdir}/httpd/user.d/welcome.conf

install -m644 %{SOURCE100} %{buildroot}%{contentdir}/error/noindex.html

install -m644 %{SOURCE105} %{buildroot}%{contentdir}/icons/blank.gif
install -m755 %{SOURCE106} %{buildroot}%{_sbindir}/httpd_callstack

# Make suexec a+rw so it can be stripped.  %%files lists real permissions
chmod 755 %{buildroot}%{_sbindir}/suexec

# Error Document
install -d -m755 $RPM_BUILD_ROOT%{contentdir}/error
cp -af ServerError/* $RPM_BUILD_ROOT/%{contentdir}/error/
cp -af ServerError/include/*.gif $RPM_BUILD_ROOT%{contentdir}/icons/

# move manual to /usr/share/httpd
mkdir -p %{buildroot}%{_datadir}/httpd/
mv %{buildroot}%{contentdir}/manual/ %{buildroot}%{_datadir}/httpd/

%if %with_embededapr
cd $RPM_BUILD_ROOT%{_libdir}/pkgconfig
mv apr-1.pc httpd-apr-1.pc
mv apr-util-1.pc httpd-apr-util-1.pc
cd -
%endif

%post
# Register the httpd service
if [ $1 = 1 ]; then
	/sbin/chkconfig --add httpd
	/sbin/chkconfig --level 35 httpd on
fi

%preun
if [ $1 = 0 ]; then
	/sbin/service httpd stop > /dev/null 2>&1
	/sbin/chkconfig --del httpd
fi

%check
# Check the built modules are all PIC
if readelf -d %{buildroot}%{_libdir}/httpd/modules/*.so | grep TEXTREL; then
   : modules contain non-relocatable code
   exit 1
fi

# Verify that the same modules were built into the httpd binaries
./prefork/httpd -l | grep -v prefork > prefork.mods
for mpm in worker; do
  ./${mpm}/httpd -l | grep -v ${mpm} > ${mpm}.mods
  if ! diff -u prefork.mods ${mpm}.mods; then
    : Different modules built into httpd binaries, will not proceed
    exit 1
  fi
done

(
	if [ "%{contentdir}" != "/var/www" ]; then
		cd %{buildroot}/var
		ln -sf %{contentdir} www
		cd -
	fi
)

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)

#doc ABOUT_APACHE README CHANGES LICENSE VERSIONING NOTICE

%dir %{_sysconfdir}/httpd
%{_sysconfdir}/httpd/modules
%{_sysconfdir}/httpd/logs
%{_sysconfdir}/httpd/run
%dir %{_sysconfdir}/httpd/conf

%dir %{contentdir}/html/
/var/www

%{_sbindir}/ht*
%exclude %{_sbindir}/httpd_callstack
%{_sbindir}/apachectl
%{_sbindir}/rotatelogs
%attr(4510,root,%{suexec_caller}) %{_sbindir}/suexec

%dir %{_libdir}/httpd
%dir %{_libdir}/httpd/modules
%{_libdir}/httpd/modules/mod*.so
%exclude %{_libdir}/httpd/modules/mod_ssl.so

%if %with_embededapr
%dir %{_libdir}/httpd/apr-util-1
%{_libdir}/httpd/apr-util-1/*.so
%{_libdir}/httpd/libapr*.so.*
%endif

%attr(0700,nobody,nobody) %dir %{_localstatedir}/lib/dav
%attr(0700,nobody,nobody) %dir %{_localstatedir}/cache/mod_proxy

%{_mandir}/man?/*
%exclude %{_mandir}/man1/*.1*
%exclude %{_mandir}/man8/apxs.8*

%files manual
%defattr(-,root,root)
%{_datadir}/httpd/manual
%config(noreplace) %{_sysconfdir}/httpd/user.d/manual.conf

%files ssl
%defattr(-,root,root)
%{_libdir}/httpd/modules/mod_ssl.so
%attr(0700,nobody,root) %dir %{_localstatedir}/cache/mod_ssl
%attr(0600,nobody,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.dir
%attr(0600,nobody,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.pag
%attr(0600,nobody,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.sem
%config(noreplace) %{_sysconfdir}/httpd/conf.d/ssl.conf

%files devel
%defattr(-,root,root)
%{_includedir}/httpd
%{_sbindir}/apxs
%{_mandir}/man8/apxs.8*
%dir %{_libdir}/httpd/build
%{_libdir}/httpd/build/libtool
%{_libdir}/httpd/build/*.mk
%{_libdir}/httpd/build/*.sh
%{_libdir}/httpd/build/*.awk

%if %with_embededapr
%{_libdir}/httpd/apr-util-1/*.*a
%{_libdir}/httpd/libapr*.so
%{_libdir}/httpd/libapr*.*a
%{_libdir}/httpd/ap*-config
%{_libdir}/pkgconfig/httpd-*.pc
%endif

%files tools
%defattr(-,root,root)
%{_bindir}/*
%{_sbindir}/httpd_callstack
%{_mandir}/man1/*

%changelog
* Sun Jan 22 2017 JoungKyun.Kim <http://oops.org> 1:2.2.32-1%{?dist}
- update 2.2.32
  http://www.apache.org/dist/httpd/CHANGES_2.2.32
- security issues:
  . CVE-2016-8743
    Enforce HTTP request grammar corresponding to RFC7230 for request lines
    and request headers, to prevent response splitting and cache pollution by
    malicious clients or downstream proxies.

* Wed Jul 20 2016 JoungKyun.Kim <http://oops.org> 1:2.2.31-2%{?dist}
- security issues:
  . CVE-2016-5387
    The Apache HTTP Server through 2.4.23 follows RFC 3875 section 4.1.18 and
    therefore does not protect applications from the presence of untrusted
    client data in the HTTP_PROXY environment variable, which might allow
    remote attackers to redirect an application's outbound HTTP traffic to an
    arbitrary proxy server via a crafted Proxy header in an HTTP request, aka
    an "httpoxy" issue.

* Sun Aug 16 2015 JoungKyun.Kim <http://oops.org> 1:2.2.31-1%{?dist}
- update 2.2.31
- security issues:
  . CVE-2015-3183
    Remove apr_brigade_flatten(), buffering and duplicated code from
    the HTTP_IN filter, parse chunks in a single pass with zero copy.
    Limit accepted chunk-size to 2^63-1 and be strict about chunk-ext
    authorized characters

* Tue Sep 23 2014 JoungKyun.Kim <http://oops.org> 1:2.2.29-1%{?dist}
- security issues:
  . CVE-2013-5704
    The mod_headers module in the Apache HTTP Server 2.2.22 allows
	remote attackers to bypass "RequestHeader unset" directives by
	placing a header in the trailer portion of data sent with chunked
	transfer coding.

* Wed Jul 30 2014 JoungKyun.Kim <http://oops.org> 1:2.2.27-2%{?dist}
- security issues:
  . CVE-2014-0118
    The deflate_in_filter function in mod_deflate.c in the mod_deflate
    module in the Apache HTTP Server before 2.4.10, when request body
    decompression is enabled, allows remote attackers to cause a denial
    of service (resource consumption) via crafted request data that
    decompresses to a much larger size.

  . CVE-2014-0226
    Race condition in the mod_status module in the Apache HTTP Server
    before 2.4.10 allows remote attackers to cause a denial of service
    (heap-based buffer overflow), or possibly obtain sensitive credential
    information or execute arbitrary code, via a crafted request that
    triggers improper scoreboard handling within the status_handler
    function in modules/generators/mod_status.c and the
    lua_ap_scoreboard_worker function in modules/lua/lua_request.c.

  . CVE-2014-0231
    The mod_cgid module in the Apache HTTP Server before 2.4.10 does not
    have a timeout mechanism, which allows remote attackers to cause a
    denial of service (process hang) via a request to a CGI script that
    does not read from its stdin file descriptor.

* Sat Apr  5 2014 JoungKyun.Kim <http://oops.org> 1:2.2.27-1%{?dist}
- update 2.2.27
  . see also http://www.apache.org/dist/httpd/CHANGES_2.2.27

- support NPN on mod_ssl

- security issues:
  . CVE-2014-0098
    Clean up cookie logging with fewer redundant string parsing passes.
    Log only cookies with a value assignment. Prevents segfaults when
    logging truncated cookies.

  . CVE-2013-6438
    mod_dav: Keep track of length of cdata properly when removing
    leading spaces. Eliminates a potential denial of service from
    specifically crafted DAV WRITE requests


* Fri Feb  7 2014 JoungKyun.Kim <http://oops.org> 1:2.2.26-1%{?dist}
- update 2.2.26
  . see also http://www.apache.org/dist/httpd/CHANGES_2.2.26

* Sat Jul  6 2013 JoungKyun.Kim <http://oops.org> 1:2.2.25-1%{?dist}
- update 2.2.25
  . see also http://www.apache.org/dist/httpd/CHANGES_2.2.25

- security issues:
  . CVE-2013-1862
    mod_rewrite.c in the mod_rewrite module in the Apache HTTP Server
    2.2.x before 2.2.25 writes data to a log file without sanitizing
    non-printable characters, which might allow remote attackers to
    execute arbitrary commands via an HTTP request containing an escape
    sequence for a terminal emulator.

* Fri Mar  8 2013 JoungKyun.Kim <http://oops.org> 1:2.2.24-1%{?dist}
- update 2.2.24
  . see also http://www.apache.org/dist/httpd/CHANGES_2.2.24

- security issues:
  . CVE-2012-3499
    Various XSS flaws due to unescaped hostnames and URIs HTML output in
    mod_info, mod_status, mod_imagemap, mod_ldap, and mod_proxy_ftp.

  . CVE-2012-4558
    XSS in mod_proxy_balancer manager interface.

* Fri Nov  9 2012 JoungKyun.Kim <http://oops.org> 1:2.2.23-3%{?dist}
- fixed worker binary

* Mon Oct 15 2012 JoungKyun.Kim <http://oops.org> 1:2.2.23-2%{?dist}
- use embeded apr

* Fri Oct 12 2012 JoungKyun.Kim <http://oops.org> 1:2.2.23-1%{?dist}
- update 2.2.23
- fixed CVE-2012-0883
- fixed CVE-2012-2687

* Fri Jun 08 2012 JoungKyun.Kim <http://oops.org> 1:2.2.22-3%{?dist}
- momve to /var/log/httpd to httpd-conf package

* Mon Mar 22 2012 JoungKyun.Kim <http://oops.org> 1:2.2.22-2%{?dist}
- fixed broken echo hangul variable on ssi

* Fri Feb 17 2012 JoungKyun.Kim <http://oops.org> 1:2.2.22-1%{?dist}
- update 2.2.22

* Mon Aug 10 2011 JoungKyun.Kim <http://oops.org> 2.2.19-1%{?dist}
- update 2.2.19
- add MaxStatusProc directive
- add External404Title directive
- add External404Iframe directive. Default value is off
- if give --with cent4, use bundle pcre and require apr12 and apr12-util
