#!/bin/bash

bash << EOF > /tmp/.gdb_tmp_$$
echo "set pag off"
cat << "EEOF"
define dump_bt2
    set \$t = \$arg0
    if \$t
        while \$t
            if \$t->function_state.function->common.function_name
                printf "%s() ", \$t->function_state.function->common.function_name
            else
                printf "??? "
            end
            if \$t->op_array != 0
                printf "%s:%d ", \$t->op_array->filename, \$t->opline->lineno
            end
            set \$t = \$t->prev_execute_data
            printf "\\n"
        end
    else
        where
    end
end
EEOF
for p in \`ps awux|grep httpd|grep "nobody\|apache"|cut -c9-15|head -300\`
do
    echo "echo __MY_START\n"
    echo "attach \$p"
    echo "dump_bt2 executor_globals.current_execute_data"
    echo "detach"
    echo "echo __MY_END\n"
done
#echo "exit"
#sleep 10
EOF
gdb -q -batch -x /tmp/.gdb_tmp_$$  /usr/sbin/httpd 2> /dev/null |grep -v 'New Thread '|sed -n '
$ {q}
:FIRST
/__MY_START/ {
    n
    h
    :LOOP
    n
	s/make_child (\(.*\), slot=.*)/make_child (\1, slot=*)/g
    /__MY_END/ b END
    H
    b LOOP
}
:END
g
s/\n/__MY_EOL__/g
s/$/__MY_EOL__/g
p
d
b FIRST

' |sort|uniq -c|sort|sed 's/__MY_EOL__/\n/g'

rm -f /tmp/.gdb_tmp_$$
